﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using Telerik.Windows.Controls;

namespace Diagram_CustomShape
{
	public class CustomShape : RadDiagramShape
	{
		public CustomShape()
		{
			this.Loaded += CustomShape_Loaded;
		}

		void CustomShape_Loaded(object sender, RoutedEventArgs e)
		{
			this.supressPositionChangeUpdate = true;
			this.Position = new Point(this.CenterPosition.X - this.ActualWidth / 2, this.CenterPosition.Y - this.ActualHeight / 2);
			this.supressPositionChangeUpdate = false;
		}

		public Point CenterPosition
		{
			get { return (Point)GetValue(CenterPositionProperty); }
			set { SetValue(CenterPositionProperty, value); }
		}

		// Using a DependencyProperty as the backing store for CenterPosition.  This enables animation, styling, binding, etc...
		public static readonly DependencyProperty CenterPositionProperty =
			DependencyProperty.Register("CenterPosition", typeof(Point), typeof(CustomShape), new PropertyMetadata(new Point(),OnCenterPositionChanged));

		private static void OnCenterPositionChanged(DependencyObject d, DependencyPropertyChangedEventArgs e)
		{
			var shape = d as CustomShape;
			if (shape.supressPositionChangeUpdate)
			{
				return;
			}
			shape.supressPositionChangeUpdate = true;
			var value = (Point)e.NewValue;
			shape.Position = new Point(value.X - shape.ActualWidth / 2, value.Y - shape.ActualHeight / 2);
			shape.supressPositionChangeUpdate = false;
		}

		private bool supressPositionChangeUpdate;

		protected override void OnPositionChanged(Point oldPosition, Point newPosition)
		{
			base.OnPositionChanged(oldPosition, newPosition);
			if (!this.supressPositionChangeUpdate)
			{
				this.supressPositionChangeUpdate = true;
				this.CenterPosition = new Point(newPosition.X + this.ActualWidth / 2, newPosition.Y + this.ActualHeight / 2);
				this.supressPositionChangeUpdate = false;
			}
		}
	}
}
